diff --git a/lact-gui/src/app/root_stack/oc_page/clocks_frame.rs b/lact-gui/src/app/root_stack/oc_page/clocks_frame.rs
index 216b34d4..dbe7dce5 100644
--- a/lact-gui/src/app/root_stack/oc_page/clocks_frame.rs
+++ b/lact-gui/src/app/root_stack/oc_page/clocks_frame.rs
@@ -1,14 +1,17 @@
 use crate::app::page_section::PageSection;
+use crate::app::root_stack::action_row;
 use glib::clone;
 use gtk::prelude::*;
 use gtk::*;
 use lact_client::schema::amdgpu_sysfs;
 use lact_client::schema::amdgpu_sysfs::gpu_handle::overdrive::{ClocksTable, ClocksTableGen};
-use libadwaita::prelude::ActionRowExt;
 use std::rc::Rc;
 use std::sync::atomic::{AtomicBool, Ordering};
 use tracing::debug;
 
+#[cfg(feature = "libadwaita")]
+use libadwaita::prelude::ActionRowExt;
+
 const VOLTAGE_OFFSET_RANGE: f64 = 250.0;
 
 // The AtomicBool stores if the value was changed
@@ -17,7 +20,13 @@ pub struct ClocksFrame {
     pub container: PageSection,
     max_values_box: Box,
     heading_listbox: ListBox,
+
+    #[cfg(feature = "libadwaita")]
     advanced_switch_row: libadwaita::SwitchRow,
+
+    #[cfg(not(feature = "libadwaita"))]
+    advanced_switch_row: Switch,
+
     min_values_box: Box,
     min_sclk_adjustment: (Adjustment, Rc<AtomicBool>),
     min_mclk_adjustment: (Adjustment, Rc<AtomicBool>),
@@ -39,18 +48,32 @@ impl ClocksFrame {
             .selection_mode(SelectionMode::None)
             .build();
 
-        heading_listbox.append(&libadwaita::ActionRow::builder()
-            .css_classes(["warning"])
-            .title("Warning!")
-            .subtitle("Changing these values may lead to system instability and potentially damage your hardware!")
-            .subtitle_lines(0)
-            .build());
+        let warning_row = action_row(
+            "Warning!",
+            Some("Changing these values may lead to system instability and potentially damage your hardware!"),
+            &Vec::<&Widget>::new(),
+            Some(&vec!["warning"]));
+
+        heading_listbox.append(&warning_row);
+
+        #[cfg(feature = "libadwaita")]
+        let advanced_switch_row = {
+            let row = libadwaita::SwitchRow::builder()
+                .title("Advanced mode")
+                .active(false)
+                .build();
+            heading_listbox.append(&row);
+            row
+        };
+
+        #[cfg(not(feature = "libadwaita"))]
+        let advanced_switch_row = {
+            let switch = Switch::builder().active(false).build();
+            let row = action_row("Advanced mode", None, &[&switch], None);
 
-        let advanced_switch_row = libadwaita::SwitchRow::builder()
-            .title("Advanced mode")
-            .active(false)
-            .build();
-        heading_listbox.append(&advanced_switch_row);
+            heading_listbox.append(&row);
+            switch
+        };
 
         container.append(&heading_listbox);
 
@@ -113,14 +136,14 @@ impl ClocksFrame {
             .halign(Align::Center)
             .css_classes(["destructive-action", "circular"])
             .build();
-        let reset_row = libadwaita::ActionRow::builder()
-            .title("Reset values")
-            .subtitle(
-                "Warning: this will reset all clock and voltage settings to their default values",
-            )
-            .subtitle_lines(0)
-            .build();
-        reset_row.add_suffix(&reset_button);
+
+        let reset_row = action_row(
+            "Reset values",
+            Some("Warning: this will reset all clock and voltage settings to their default values"),
+            &[&reset_button],
+            None,
+        );
+
         max_values_listbox.append(&reset_row);
 
         let clocks_data_unavailable_label = Label::builder()
@@ -370,11 +393,23 @@ fn extract_value_and_range(
 fn oc_adjustment(title: &'static str, listbox: &ListBox) -> (Adjustment, Rc<AtomicBool>) {
     let adjustment = Adjustment::new(0.0, 0.0, 0.0, 1.0, 10.0, 0.0);
 
+    #[cfg(feature = "libadwaita")]
     let value_selector = libadwaita::SpinRow::builder()
         .title(title)
         .adjustment(&adjustment)
         .build();
 
+    #[cfg(not(feature = "libadwaita"))]
+    let value_selector = {
+        let spin_btn = SpinButton::builder()
+            .adjustment(&adjustment)
+            .valign(Align::Center)
+            .build();
+        let row = action_row(title, None, &[&spin_btn], None);
+        row.set_child(Some(&spin_btn));
+        spin_btn
+    };
+
     let changed = Rc::new(AtomicBool::new(false));
 
     adjustment.connect_value_changed(clone!(@strong changed => move |_| {
diff --git a/lact-gui/src/app/root_stack/oc_page/mod.rs b/lact-gui/src/app/root_stack/oc_page/mod.rs
index 3d086b4e..d914cf87 100644
--- a/lact-gui/src/app/root_stack/oc_page/mod.rs
+++ b/lact-gui/src/app/root_stack/oc_page/mod.rs
@@ -8,6 +8,7 @@ mod power_states;
 
 use self::power_cap_section::PowerCapSection;
 use self::power_states::power_states_frame::PowerStatesFrame;
+use super::list_clamp;
 use clocks_frame::ClocksFrame;
 use gpu_stats_section::GpuStatsSection;
 use gtk::*;
@@ -18,8 +19,6 @@ use lact_client::schema::{
     DeviceStats, SystemInfo,
 };
 use performance_frame::PerformanceFrame;
-// use power_cap_frame::PowerCapFrame;
-use super::list_clamp;
 use std::collections::HashMap;
 use tracing::warn;
 
@@ -28,7 +27,6 @@ pub struct OcPage {
     pub container: ScrolledWindow,
     stats_section: GpuStatsSection,
     pub performance_frame: PerformanceFrame,
-    // power_cap_frame: PowerCapFrame,
     power_cap_section: PowerCapSection,
     pub power_states_frame: PowerStatesFrame,
     pub clocks_frame: ClocksFrame,
@@ -51,7 +49,17 @@ impl OcPage {
         if system_info.amdgpu_overdrive_enabled == Some(false) {
             let (warning_frame, button) = oc_warning_frame();
             enable_overclocking_button = Some(button);
-            vbox.append(&warning_frame);
+
+            #[cfg(feature = "libadwaita")]
+            vbox.append(
+                &libadwaita::Bin::builder()
+                    .css_classes(["card"])
+                    .child(&warning_frame)
+                    .build(),
+            );
+
+            #[cfg(not(feature = "libadwaita"))]
+            vbox.append(&Frame::builder().child(&warning_frame).build());
         }
 
         let stats_section = GpuStatsSection::new();
@@ -166,7 +174,7 @@ impl OcPage {
     }
 }
 
-fn oc_warning_frame() -> (libadwaita::Bin, Button) {
+fn oc_warning_frame() -> (Box, Button) {
     let vbox = Box::builder()
         .orientation(Orientation::Vertical)
         .spacing(6)
@@ -218,11 +226,5 @@ fn oc_warning_frame() -> (libadwaita::Bin, Button) {
 
     vbox.append(&enable_button);
 
-    (
-        libadwaita::Bin::builder()
-            .css_classes(["card"])
-            .child(&vbox)
-            .build(),
-        enable_button,
-    )
+    (vbox, enable_button)
 }
diff --git a/lact-gui/src/app/root_stack/oc_page/performance_frame.rs b/lact-gui/src/app/root_stack/oc_page/performance_frame.rs
index 52187ba8..5b5d25e8 100644
--- a/lact-gui/src/app/root_stack/oc_page/performance_frame.rs
+++ b/lact-gui/src/app/root_stack/oc_page/performance_frame.rs
@@ -1,18 +1,31 @@
-use crate::app::page_section::PageSection;
+use crate::app::{page_section::PageSection, root_stack::action_row};
 use glib::clone;
 use gtk::prelude::*;
 use gtk::*;
 use lact_client::schema::amdgpu_sysfs::gpu_handle::{
     power_profile_mode::PowerProfileModesTable, PerformanceLevel,
 };
-use libadwaita::prelude::{ActionRowExt, ComboRowExt};
 use std::{cell::RefCell, rc::Rc, str::FromStr};
 
+#[cfg(feature = "libadwaita")]
+use libadwaita::prelude::{ActionRowExt, ComboRowExt};
+
 #[derive(Debug, Clone)]
 pub struct PerformanceFrame {
     pub container: PageSection,
+
+    #[cfg(feature = "libadwaita")]
     level_row: libadwaita::ComboRow,
+    #[cfg(feature = "libadwaita")]
     mode_row: libadwaita::ComboRow,
+
+    #[cfg(not(feature = "libadwaita"))]
+    level_row: DropDown,
+    #[cfg(not(feature = "libadwaita"))]
+    level_subtitle: Label,
+    #[cfg(not(feature = "libadwaita"))]
+    mode_row: DropDown,
+
     modes_table: Rc<RefCell<Option<PowerProfileModesTable>>>,
 }
 
@@ -29,33 +42,83 @@ impl PerformanceFrame {
             .into_iter()
             .collect();
 
-        let level_row = libadwaita::ComboRow::builder()
-            .model(&levels_model)
-            .title("Performance level")
-            .subtitle("")
-            .subtitle_lines(0)
-            .sensitive(false)
-            .build();
+        #[cfg(feature = "libadwaita")]
+        let level_row = {
+            let row = libadwaita::ComboRow::builder()
+                .model(&levels_model)
+                .title("Performance level")
+                .subtitle("")
+                .subtitle_lines(0)
+                .sensitive(false)
+                .build();
+            listbox.append(&row);
+            row
+        };
 
-        listbox.append(&level_row);
+        #[cfg(not(feature = "libadwaita"))]
+        let level_subtitle;
+        #[cfg(not(feature = "libadwaita"))]
+        let level_row = {
+            let dropdown = DropDown::builder()
+                .model(&levels_model)
+                .sensitive(false)
+                .valign(Align::Center)
+                .build();
+            let row = action_row("Performance level", Some(""), &[&dropdown], None);
+            level_subtitle = row
+                .first_child()
+                .unwrap()
+                .first_child()
+                .unwrap()
+                .first_child()
+                .unwrap()
+                .next_sibling()
+                .unwrap()
+                .downcast::<Label>()
+                .unwrap();
+            listbox.append(&row);
+            dropdown
+        };
 
         let filler_model: StringList = [""].into_iter().collect();
 
-        let mode_row = libadwaita::ComboRow::builder()
-            .model(&filler_model)
-            .title("Power level mode")
-            .subtitle("Set \"Performance level\" to \"Manual\" to use power states and modes")
-            .subtitle_lines(0)
-            .sensitive(false)
-            .build();
+        #[cfg(feature = "libadwaita")]
+        let mode_row = {
+            let row = libadwaita::ComboRow::builder()
+                .model(&filler_model)
+                .title("Power level mode")
+                .subtitle("Set \"Performance level\" to \"Manual\" to use power states and modes")
+                .subtitle_lines(0)
+                .sensitive(false)
+                .build();
+            listbox.append(&row);
+            row
+        };
 
-        listbox.append(&mode_row);
+        #[cfg(not(feature = "libadwaita"))]
+        let mode_row = {
+            let dropdown = DropDown::builder()
+                .model(&filler_model)
+                .sensitive(false)
+                .valign(Align::Center)
+                .build();
+            let row = action_row(
+                "Power level mode",
+                Some("Set \"Performance level\" to \"Manual\" to use power states and modes"),
+                &[&dropdown],
+                None,
+            );
+            listbox.append(&row);
+            dropdown
+        };
 
         container.append(&listbox);
 
         let frame = Self {
             container,
             level_row,
+            #[cfg(not(feature = "libadwaita"))]
+            level_subtitle,
             mode_row,
             modes_table: Rc::new(RefCell::new(None)),
         };
@@ -145,17 +208,23 @@ impl PerformanceFrame {
     fn update_from_selection(&self) {
         let mut enable_mode_control = false;
 
-        self.level_row
-            .set_subtitle(match self.level_row.selected() {
-                0 => "Automatically adjust GPU and VRAM clocks. (Default)",
-                1 => "Always use the highest clockspeeds for GPU and VRAM.",
-                2 => "Always use the lowest clockspeeds for GPU and VRAM.",
-                3 => {
-                    enable_mode_control = true;
-                    "Manual performance control."
-                }
-                _ => unreachable!(),
-            });
+        let subtitle = match self.level_row.selected() {
+            0 => "Automatically adjust GPU and VRAM clocks. (Default)",
+            1 => "Always use the highest clockspeeds for GPU and VRAM.",
+            2 => "Always use the lowest clockspeeds for GPU and VRAM.",
+            3 => {
+                enable_mode_control = true;
+                "Manual performance control."
+            }
+            _ => unreachable!(),
+        };
+
+        #[cfg(feature = "libadwaita")]
+        self.level_row.set_subtitle(subtitle);
+
+        #[cfg(not(feature = "libadwaita"))]
+        self.level_subtitle.set_text(subtitle);
+
         self.mode_row.set_sensitive(enable_mode_control);
     }
 
diff --git a/lact-gui/src/app/root_stack/oc_page/power_cap_section.rs b/lact-gui/src/app/root_stack/oc_page/power_cap_section.rs
index 1ad30a40..99937681 100644
--- a/lact-gui/src/app/root_stack/oc_page/power_cap_section.rs
+++ b/lact-gui/src/app/root_stack/oc_page/power_cap_section.rs
@@ -41,6 +41,7 @@ mod imp {
     };
     use std::cell::RefCell;
 
+    #[cfg(feature = "libadwaita")]
     #[derive(CompositeTemplate, Default, Properties)]
     #[properties(wrapper_type = super::PowerCapSection)]
     #[template(file = "ui/oc_page/power_cap_section.blp")]
@@ -62,6 +63,28 @@ mod imp {
         pub reset_button: TemplateChild<Button>,
     }
 
+    #[cfg(not(feature = "libadwaita"))]
+    #[derive(CompositeTemplate, Default, Properties)]
+    #[properties(wrapper_type = super::PowerCapSection)]
+    #[template(file = "ui/oc_page/power_cap_section_gtk.blp")]
+    pub struct PowerCapSection {
+        #[property(get, set)]
+        pub current_value: RefCell<f64>,
+        #[property(get, set)]
+        pub max_value: RefCell<f64>,
+        #[property(get, set)]
+        pub min_value: RefCell<f64>,
+        #[property(get, set)]
+        pub default_value: RefCell<f64>,
+        #[property(get, set)]
+        pub value_text: RefCell<String>,
+
+        #[template_child]
+        pub adjustment: TemplateChild<OcAdjustment>,
+        #[template_child]
+        pub reset_button: TemplateChild<Button>,
+    }
+
     #[glib::object_subclass]
     impl ObjectSubclass for PowerCapSection {
         const NAME: &'static str = "PowerCapSection";
diff --git a/lact-gui/src/app/root_stack/thermals_page/mod.rs b/lact-gui/src/app/root_stack/thermals_page/mod.rs
index 66198d9f..6d182bf3 100644
--- a/lact-gui/src/app/root_stack/thermals_page/mod.rs
+++ b/lact-gui/src/app/root_stack/thermals_page/mod.rs
@@ -7,6 +7,8 @@ use glib::clone;
 use gtk::prelude::*;
 use gtk::*;
 use lact_client::schema::{default_fan_curve, DeviceStats, FanControlMode, FanCurveMap};
+
+#[cfg(feature = "libadwaita")]
 use libadwaita::prelude::*;
 
 #[derive(Debug)]
@@ -81,15 +83,18 @@ impl ThermalsPage {
 
         fan_control_mode_stack.add_titled(&fan_curve_frame.container, Some("curve"), "Curve");
 
-        fan_control_mode_stack.add_titled(
-            &libadwaita::Bin::builder()
-                .css_classes(["card"])
-                .valign(Align::Start)
-                .child(&fan_static_speed_frame)
-                .build(),
-            Some("static"),
-            "Static",
-        );
+        #[cfg(feature = "libadwaita")]
+        let static_speed_container = libadwaita::Bin::builder()
+            .css_classes(["card"])
+            .valign(Align::Start)
+            .child(&fan_static_speed_frame)
+            .build();
+        #[cfg(not(feature = "libadwaita"))]
+        let static_speed_container = Frame::builder()
+            .valign(Align::Start)
+            .child(&fan_static_speed_frame)
+            .build();
+        fan_control_mode_stack.add_titled(&static_speed_container, Some("static"), "Static");
 
         fan_control_section.append(&fan_control_mode_stack_switcher);
         fan_control_section.append(&fan_control_mode_stack);
diff --git a/lact-gui/src/lib.rs b/lact-gui/src/lib.rs
index 33d145e1..959c6a3e 100644
--- a/lact-gui/src/lib.rs
+++ b/lact-gui/src/lib.rs
@@ -17,7 +17,13 @@ pub fn run(args: GuiArgs) -> anyhow::Result<()> {
         .context("Invalid log level")?;
     tracing_subscriber::fmt().with_env_filter(env_filter).init();
 
+    #[cfg(feature = "libadwaita")]
     if let Err(err) = libadwaita::init() {
+        return Err(anyhow!("Cannot initialize Libadwaita: {err}"));
+    }
+
+    #[cfg(not(feature = "libadwaita"))]
+    if let Err(err) = gtk::init() {
         return Err(anyhow!("Cannot initialize GTK: {err}"));
     }
 
diff --git a/lact-gui/ui/oc_page/power_cap_section_gtk.blp b/lact-gui/ui/oc_page/power_cap_section_gtk.blp
new file mode 100644
index 00000000..8d86b01b
--- /dev/null
+++ b/lact-gui/ui/oc_page/power_cap_section_gtk.blp
@@ -0,0 +1,36 @@
+using Gtk 4.0;
+
+template $PowerCapSection: $PageSection {
+    name: "Power usage limit";
+
+    Box {
+        orientation: horizontal;
+        margin-top: 12;
+        margin-bottom: 12;
+        spacing: 6;
+        
+        Label value_label {
+            label: bind template.value-text;
+        }
+
+        Scale {
+            orientation: horizontal;
+            hexpand: true;
+            round-digits: 0;
+            draw-value: false;
+            adjustment: adjustment;
+        }
+        
+        Button reset_button {
+            styles ["circular", "flat"]
+            icon-name: "view-refresh-symbolic";
+            tooltip-text: "Reset to default";
+        }
+    }
+}
+
+$OcAdjustment adjustment {
+    value: bind template.current-value bidirectional;
+    lower: bind template.min-value;
+    upper: bind template.max-value;
+}
diff --git a/lact-gui/ui/vulkan_features_window_gtk.blp b/lact-gui/ui/vulkan_features_window_gtk.blp
new file mode 100644
index 00000000..3da9435f
--- /dev/null
+++ b/lact-gui/ui/vulkan_features_window_gtk.blp
@@ -0,0 +1,45 @@
+using Gtk 4.0;
+
+template $VulkanFeaturesWindow: Window {
+    default-height: 700;
+    default-width: 500;
+
+    Box {
+        orientation: vertical;
+
+        [top] SearchEntry search_entry {
+            margin-top: 6;
+            margin-bottom: 6;
+            margin-start: 12;
+            margin-end: 12;
+        }
+
+        Box {
+            orientation: vertical;
+    
+            ScrolledWindow {
+                vexpand: true;
+                hscrollbar-policy: never;
+    
+                ListView {
+                    factory: features_factory;
+                    model: selection_model;
+                    show-separators: true;
+                }
+            }
+        }
+    }
+}
+
+SignalListItemFactory features_factory {}
+
+NoSelection selection_model {
+    model: filter_model;
+}
+
+StringFilter search_filter {}
+
+FilterListModel filter_model {
+    filter: search_filter;
+    incremental: true;
+}

